<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfUrunBarkod ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfUrunBarkod
 * @subpackage Arrays
 */
class ArrayOfUrunBarkod extends AbstractStructArrayBase
{
    /**
     * The UrunBarkod
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\UrunBarkod[]
     */
    public $UrunBarkod;
    /**
     * Constructor method for ArrayOfUrunBarkod
     * @uses ArrayOfUrunBarkod::setUrunBarkod()
     * @param \StructType\UrunBarkod[] $urunBarkod
     */
    public function __construct(array $urunBarkod = array())
    {
        $this
            ->setUrunBarkod($urunBarkod);
    }
    /**
     * Get UrunBarkod value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\UrunBarkod[]|null
     */
    public function getUrunBarkod()
    {
        return isset($this->UrunBarkod) ? $this->UrunBarkod : null;
    }
    /**
     * This method is responsible for validating the values passed to the setUrunBarkod method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUrunBarkod method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateUrunBarkodForArrayConstraintsFromSetUrunBarkod(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfUrunBarkodUrunBarkodItem) {
            // validation for constraint: itemType
            if (!$arrayOfUrunBarkodUrunBarkodItem instanceof \StructType\UrunBarkod) {
                $invalidValues[] = is_object($arrayOfUrunBarkodUrunBarkodItem) ? get_class($arrayOfUrunBarkodUrunBarkodItem) : sprintf('%s(%s)', gettype($arrayOfUrunBarkodUrunBarkodItem), var_export($arrayOfUrunBarkodUrunBarkodItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The UrunBarkod property can only contain items of type \StructType\UrunBarkod, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set UrunBarkod value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\UrunBarkod[] $urunBarkod
     * @return \ArrayType\ArrayOfUrunBarkod
     */
    public function setUrunBarkod(array $urunBarkod = array())
    {
        // validation for constraint: array
        if ('' !== ($urunBarkodArrayErrorMessage = self::validateUrunBarkodForArrayConstraintsFromSetUrunBarkod($urunBarkod))) {
            throw new \InvalidArgumentException($urunBarkodArrayErrorMessage, __LINE__);
        }
        if (is_null($urunBarkod) || (is_array($urunBarkod) && empty($urunBarkod))) {
            unset($this->UrunBarkod);
        } else {
            $this->UrunBarkod = $urunBarkod;
        }
        return $this;
    }
    /**
     * Add item to UrunBarkod value
     * @throws \InvalidArgumentException
     * @param \StructType\UrunBarkod $item
     * @return \ArrayType\ArrayOfUrunBarkod
     */
    public function addToUrunBarkod(\StructType\UrunBarkod $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\UrunBarkod) {
            throw new \InvalidArgumentException(sprintf('The UrunBarkod property can only contain items of type \StructType\UrunBarkod, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->UrunBarkod[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\UrunBarkod|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\UrunBarkod|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\UrunBarkod|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\UrunBarkod|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\UrunBarkod|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string UrunBarkod
     */
    public function getAttributeName()
    {
        return 'UrunBarkod';
    }
}
